;	org $1001-2
;	dw  $1001
;	
;	dw nextln,0	; second word is line number
;	db $9E,"4109",0
;nextln	db 0,0

line_dest_ptr = $A0

line_x1 = $A2
line_y1 = line_x1+1
line_x2 = line_x1+2
line_y2 = line_x1+3

line_temp_0 = $A6
line_temp_1 = line_temp_0+1
line_temp_2 = line_temp_0+2
line_temp_3 = line_temp_0+3

line_font = $F000
div8 = $F900
and7 = $FA00

sine_idx1 = $AA
sine_idx2 = $AB
sine_idx3 = $AC

drawline macro	x1,y1,x2,y2
	lda #x1
	sta line_x1
	lda #y1
	sta line_y1
	lda #x2
	sta line_x2
	lda #y2    
	sta line_y2
	jsr draw_line
	endm
	
;start
;	sei
;	sta $ff3f
;	;
;	lda #$40
;	sta $FF19
;	;
;	jsr line_init
;	;
;	
;	;
;	lda #$00
;	sta $FF12
;	lda #line_font >> 8
;	sta $FF13
;	lda $FF07
;	and #$40
;	ora #$88
;	sta $FF07
;	;
;zzz1	
;	lda #$CC
;	cmp $FF1D
;	bne *-3

triangles_draw	
	if DEBUG
	dec $FF19
	endif
	;
	lda $FF07
	and #$40
	bne td_ntsc
	;
	; --- clear
	;
	lda #$00
	ldx #9*8-1
tcloop	sta line_font+$000,x
	sta line_font+$100,x
	sta line_font+$200,x
	sta line_font+$300,x
	sta line_font+$400,x
	sta line_font+$500,x
	sta line_font+$600,x
	sta line_font+$700,x
	dex
	bpl tcloop
	bmi tdly1
	;
td_ntsc
	lda #$00
	ldx #7*8-1
tcloop2	sta line_font+$208,x
	sta line_font+$308,x
	sta line_font+$408,x
	sta line_font+$508,x
	dex
	bpl tcloop2
	;
	ldx #5*8-1
tcloop3	sta line_font+$110,x
	sta line_font+$610,x
	dex
	bpl tcloop3
	;
	; --- move
	;
tdly1	ldx #84			; initial delay: wait until indexes start increasing
	beq tdly1a
	dex
	stx tdly1+1
	jmp tdly2
	;
tdly1a	lda #$00
	beq tdly1b
	;
	lda sine_idx1
	cmp #$40
	beq tdly2
	;
tdly1b	lda sine_idx1
	clc
	adc #$01
	and #$7F
	sta sine_idx1
	;
tdly2	ldx #42
	beq tdly2a
	dex
	stx tdly2+1
	jmp tdly3
	;
tdly2a	lda #$00
	beq tdly2b
	;
	lda sine_idx2
	cmp #$40
	beq tdly3
	;
tdly2b	lda sine_idx2
	clc
	adc #$01
	and #$7F
	sta sine_idx2
	;
tdly3	ldx #0
	beq tdly3a
	dex
	stx tdly3+1
	jmp tdly4
	;
tdly3a	lda #$00
	beq tdly3b
	;
	lda sine_idx3
	cmp #$40
	beq tdly4
	;
tdly3b	lda sine_idx3
	clc
	adc #$01
	and #$7F
	sta sine_idx3
tdly4
	;
	; --- draw
	;
	ldx sine_idx1
	ldy sine_idx2
	jsr draw_xy_line
	;
	ldx sine_idx2
	ldy sine_idx3
	jsr draw_xy_line
	;
	ldx sine_idx3
	ldy sine_idx1
	jsr draw_xy_line
	;     
	if DEBUG
	inc $FF19
	endif
	;
	rts
	
	align 256
line_sine_X
;128,31.5
	db $20,$21,$23,$24,$26,$27,$29,$2A,$2C,$2D,$2E,$30,$31,$32,$33,$35
	db $36,$37,$38,$39,$3A,$3B,$3B,$3C,$3D,$3D,$3E,$3E,$3E,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$3E,$3E,$3E,$3D,$3D,$3C,$3B,$3B,$3A,$39,$38,$37
	db $36,$35,$33,$32,$31,$30,$2E,$2D,$2C,$2A,$29,$27,$26,$24,$23,$21
	db $20,$1E,$1C,$1B,$19,$18,$16,$15,$13,$12,$11,$0F,$0E,$0D,$0C,$0A
	db $09,$08,$07,$06,$05,$04,$04,$03,$02,$02,$01,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$01,$02,$02,$03,$04,$04,$05,$06,$07,$08
	db $09,$0A,$0C,$0D,$0E,$0F,$11,$12,$13,$15,$16,$18,$19,$1B,$1C,$1E
line_sine_Y
;128,35.5,0,32
	db $47,$47,$47,$47,$46,$46,$45,$45,$44,$44,$43,$42,$41,$40,$3F,$3E
	db $3D,$3B,$3A,$39,$37,$36,$34,$33,$31,$2F,$2E,$2C,$2A,$29,$27,$25
	db $24,$22,$20,$1E,$1D,$1B,$19,$18,$16,$14,$13,$11,$10,$0E,$0D,$0C
	db $0A,$09,$08,$07,$06,$05,$04,$03,$03,$02,$02,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$02,$02,$03,$03,$04,$05,$06,$07,$08,$09
	db $0A,$0C,$0D,$0E,$10,$11,$13,$14,$16,$18,$19,$1B,$1D,$1E,$20,$22
	db $23,$25,$27,$29,$2A,$2C,$2E,$2F,$31,$33,$34,$36,$37,$39,$3A,$3B
	db $3D,$3E,$3F,$40,$41,$42,$43,$44,$44,$45,$45,$46,$46,$47,$47,$47
	;
	; Separate tables for NTSC: smaller triangle = less rastertime
	;
;128,17.5,14
	db $20,$20,$21,$22,$23,$24,$25,$25,$26,$27,$28,$28,$29,$2A,$2B,$2B
	db $2C,$2C,$2D,$2E,$2E,$2F,$2F,$2F,$30,$30,$30,$30,$31,$31,$31,$31
	db $31,$31,$31,$31,$31,$30,$30,$30,$30,$2F,$2F,$2F,$2E,$2E,$2D,$2C
	db $2C,$2B,$2B,$2A,$29,$28,$28,$27,$26,$25,$25,$24,$23,$22,$21,$20
	db $20,$1F,$1E,$1D,$1C,$1B,$1A,$1A,$19,$18,$17,$17,$16,$15,$14,$14
	db $13,$13,$12,$11,$11,$10,$10,$10,$0F,$0F,$0F,$0F,$0E,$0E,$0E,$0E
	db $0E,$0E,$0E,$0E,$0E,$0F,$0F,$0F,$0F,$10,$10,$10,$11,$11,$12,$13
	db $13,$14,$14,$15,$16,$17,$17,$18,$19,$1A,$1A,$1B,$1C,$1D,$1E,$1F
;128,21.5,14,32
	db $39,$39,$39,$39,$39,$38,$38,$38,$37,$37,$36,$36,$35,$35,$34,$33
	db $33,$32,$31,$30,$2F,$2F,$2E,$2D,$2C,$2B,$2A,$29,$28,$27,$26,$25
	db $24,$22,$21,$20,$1F,$1E,$1D,$1C,$1B,$1A,$19,$18,$18,$17,$16,$15
	db $14,$14,$13,$12,$12,$11,$11,$10,$10,$0F,$0F,$0F,$0E,$0E,$0E,$0E
	db $0E,$0E,$0E,$0E,$0E,$0F,$0F,$0F,$10,$10,$11,$11,$12,$12,$13,$14
	db $14,$15,$16,$17,$18,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20,$21,$22
	db $23,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$2F,$30,$31,$32
	db $33,$33,$34,$35,$35,$36,$36,$37,$37,$38,$38,$38,$39,$39,$39,$39
	
triangles_prepare
	lda #($0C00+8*40)&255
	sta line_dest_ptr
	lda #($0C00+8*40)>>8
	sta line_dest_ptr+1
	;
	ldx #$00
line_il1
	ldy #$00
	txa
line_il2
	sta (line_dest_ptr),y
	clc
	adc #$20
	iny
	cpy #$28
	bne line_il2
	;
	lda line_dest_ptr
	clc
	adc #40
	sta line_dest_ptr
	bcc *+4
	inc line_dest_ptr+1
	;
	inx
	cpx #9
	bne line_il1
	;
	lda #$00
	sta line_dest_ptr
	rts

line_init
	ldx #$00
loop104	txa			; create two look up tables
	lsr a
	lsr a
	lsr a
	and #$07
	ora #line_font >> 8	; high byte of pointer
	sta div8,x
	inx
	bne loop104
	;
	ldx #$00
	lda #$80
loop106	sta and7,x		; bits to draw
	inx
	lsr a
	bcc loop106
loop107	lda and7-8,x
	sta and7,x
	inx
	bne loop107
	;
	ldx #0
	stx sine_idx1
	stx sine_idx2
	stx sine_idx3
	;
	lda $FF07
	and #$40
	beq line_pal
	;
loop108	lda line_sine_X+$100,x	; on NTSC, copy the NTSC tables (256 bytes)
	sta line_sine_X,x
	inx
	bne loop108
	;
line_pal
	rts
	
draw_xy_line
	lda line_sine_X,x	; check to see if coords need to be swapped
	cmp line_sine_X,y
	bcs draw_rev
	;
	lda line_sine_X,x
	sta line_x1
	lda line_sine_X,y
	sta line_x2 
	lda line_sine_Y,x
	sta line_y1
	lda line_sine_Y,y
	sta line_y2 
	;
	jmp draw_line
	;
draw_rev
	lda line_sine_X,x	; swap coordinates (to ensure line goes from left to right)
	sta line_x2
	lda line_sine_X,y
	sta line_x1 
	lda line_sine_Y,x
	sta line_y2
	lda line_sine_Y,y
	sta line_y1 
	;
	; Input: line_x1,line_y1, line_x2,line_y2
	;
draw_line
	lda line_x2
	sec
	sbc line_x1
	sta line_temp_2
	;
	ldx line_x1		; for all 4 types of line
	lda div8,x
	sta line_dest_ptr+1	; high byte
	;
	lda line_y1
	cmp line_y2
	bcs l_line_0
	jmp l_line_1	
	;--------------------
	;
l_line_0
	sec
	sbc line_y2
	sta line_temp_1
	;
	;-----------
	tay
	cpy line_temp_2
	bcc l_steep
	;
	; *** Case 1
	;
	sty s1_11 + 1
	sty s1_12 + 1
	;
	iny
	sty line_temp_3		; loop counter
	;
	tya
	lsr a
	sta line_temp_0		; line delta counter
	;
	lda and7,x
	sta or1+1
	;
	lda line_temp_2
	sta s2_11 + 1
	;
	ldy line_y1
l_loop_2
	;
	lda (line_dest_ptr),y
or1	ora #$00
	sta (line_dest_ptr),y
	;************
	;
	dey
	;
	lda line_temp_0
	clc
s2_11	adc #$00
	sta line_temp_0
	;
s1_11	cmp #$00
	bcc l_no_inc
	;
s1_12	sbc #$00		; carry is already set
	sta line_temp_0
	inx
	;
	lda div8,x
	sta line_dest_ptr+1
	lda and7,x
	sta or1+1
	;
l_no_inc
	;
	dec line_temp_3
	bne l_loop_2
	;
	rts
	;
	; *** Case 4 -----------------------------------------------
	;
l_lankas
	tay
	;
	lda #$C8		; INY opcode
	db $2C
	;
	; *** Case 2 -----------------------------------------------
	;
l_steep
	lda #$88		; DEY opcode
	sta iny_dey
	;
	sty s1_21 + 1
	;
l_type_2
	ldy line_temp_2
	sty s2_21 + 1
	sty s2_22 + 1
	iny
	sty line_temp_3		; loop counter
	;
	tya
	lsr a
	sta line_temp_0		; line_temp_0 = line_x2 Shr 1; { line_temp_0 = Round ( line_temp_2 / 2 ) }
	;
	ldy line_y1
l_loop_3
	;
	lda and7,x
	inx
	cmp #$80
	bne l_no_cb1
	;
	lda div8,x
	sta line_dest_ptr+1
	;
	lda #$80
	;
l_no_cb1
	ora (line_dest_ptr),y
	sta (line_dest_ptr),y
	;
	lda line_temp_0
	clc
s1_21	adc #$00
	;
s2_21	cmp #$00
	bcc l_no_inc2
	;
s2_22	sbc #$00
	;
iny_dey dey			; self-mod
	;-----------
l_no_inc2
	sta line_temp_0
	;
	dec line_temp_3
	bne l_loop_3
	;
	rts

l_line_1
	;*************
	lda line_y2
	sec
	sbc line_y1
	sta line_temp_1
	;
	ldy line_temp_2
	cpy line_temp_1
	bcs l_lankas
	;
	; *** Case 3
	;
	sty s2_31 + 1
	;
	tay
	sty s1_31 + 1
	sty s1_32 + 1
	iny
	sty line_temp_3
	;
	tya
	lsr a
	sta line_temp_0
	;
	lda and7,x
	sta or3+1
	;
	ldy line_y1
l_loop_5
	;
	lda (line_dest_ptr),y
or3	ora #$00
	sta (line_dest_ptr),y
	;
	iny
	;
	lda line_temp_0
	clc
s2_31	adc #$00
	sta line_temp_0
	;
s1_31	cmp #$00
	bcc l_no_inc3
	;---------
	;
s1_32	sbc #$00
	sta line_temp_0
	;
	inx
	;
	lda div8,x
	sta line_dest_ptr+1
	lda and7,x
	sta or3+1
	;---------
l_no_inc3
	;
	dec line_temp_3
	bne l_loop_5
	;
	rts
	
	;
	; Input: line_x1,line_y1, line_x2,line_y2
	;
;clear_line	
;	lda line_x2
;	sec
;	sbc line_x1
;	sta line_temp_2
;	;
;	ldx line_x1
;	lda div8,x
;	sta line_dest_ptr+1
;	;
;	lda line_y1
;	cmp line_y2
;	bcc c_line_1
;	;
;	;--------------------
;	;
;	sec
;	sbc line_y2
;	sta line_temp_1
;	;
;	cmp line_temp_2
;	bcc c_steep
;	;
;	;---
;	;
;	sta s1_51 + 1
;	sta s1_52 + 1
;	tay
;	iny
;	sty line_temp_3		; loop counter
;	;
;	tya
;	lsr a
;	sta line_temp_0		; line_temp_0 = line_x2 / 2
;	;
;	lda line_temp_2
;	sta s2_51 + 1
;	;
;	ldy line_y1
;c_loop_2
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;	dey
;	;
;	lda line_temp_0
;	clc
;s2_51	adc #$00
;	sta line_temp_0
;	;
;s1_51	cmp #$00
;	bcc c_no_inc		; if line_temp_0 >= line_temp_1
;	;----------
;s1_52	sbc #$00
;	sta line_temp_0
;	;
;	inx
;	;
;	lda div8,x
;	sta line_dest_ptr+1
;	;-----------
;c_no_inc
;	;
;	dec line_temp_3
;	bne c_loop_2
;	;
;	rts
;	;
;	;#############################
;c_steep
;	;	
;	sta s1_61 + 1
;	;	
;	ldy line_temp_2
;	sty s2_61 + 1
;	sty s2_62 + 1
;	iny
;	sty line_temp_3		; loop counter
;	;
;	tya
;	lsr a
;	sta line_temp_0		; line_temp_0 = line_x2 / 2
;	;
;	ldy line_y1
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;c_loop_3
;	;
;	inx
;	txa
;	and #$07
;	bne c_no_cb1
;	;
;	lda div8,x
;	sta line_dest_ptr+1
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;c_no_cb1
;	lda line_temp_0
;	clc
;s1_61	adc #$00
;	sta line_temp_0
;	;
;s2_61	cmp #$00
;	bcc c_no_inc2
;	;
;s2_62	sbc #$00
;	sta line_temp_0
;	;
;	dey
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;c_no_inc2
;	dec line_temp_3
;	bne c_loop_3
;	;
;	rts
;
;c_line_1
;	;#############################################################
;	lda line_y2
;	sec
;	sbc line_y1
;	sta line_temp_1
;	;
;	ldy line_temp_2
;	cpy line_temp_1
;	bcs c_lankas
;	;--------------------
;	sty s2_71 + 1
;	sta s1_71 + 1
;	sta s1_72 + 1
;	tay
;	iny
;	sty line_temp_3
;	;
;	tya
;	lsr a
;	sta line_temp_0
;	;
;	ldy line_y1
;c_loop_5
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;	iny
;	;
;	lda line_temp_0
;	clc
;s2_71	adc #$00
;	sta line_temp_0
;	;
;s1_71	cmp #$00
;	bcc c_no_inc3
;	;---------
;s1_72	sbc #$00
;	sta line_temp_0
;	;
;	inx 
;	;
;	lda div8,x
;	sta line_dest_ptr+1
;	;---------
;c_no_inc3
;	;
;	dec line_temp_3
;	bne c_loop_5
;	;
;	rts
;
;c_lankas
;	sta s1_81 + 1
;	sty s2_81 + 1
;	sty s2_82 + 1
;	iny
;	sty line_temp_3
;	;
;	tya
;	lsr a
;	sta line_temp_0	
;	;
;	ldy line_y1
;	;	
;	lda #$00
;	sta (line_dest_ptr),y
;c_loop_7
;	;
;	inx
;	txa
;	and #$07
;	bne c_no_cb2
;	;
;	lda div8,x
;	sta line_dest_ptr+1
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;c_no_cb2
;	lda line_temp_0
;	clc
;s1_81	adc #$00
;	sta line_temp_0
;	;
;s2_81	cmp #$00
;	bcc c_no_inc4
;	;
;s2_82	sbc #$00
;	sta line_temp_0
;	;
;	iny
;	;
;	lda #$00
;	sta (line_dest_ptr),y
;	;
;c_no_inc4
;	dec line_temp_3
;	bne c_loop_7
;	;
;	rts
;eof	